'**********************************************************************************************************************************
'** This script is used to change the folder names of a home directory (H Drive) to the user name of the user who has permissions
'** Explicitly defined to that folder. It scans each subfolder of the defined folder, and collects the permissions for each subfolder. 
'** It checks each permitted user account against a list of user accounts to ignore (arrayAdmins). If it finds a user account not on 
'** the list, it compares the user name to the folder name. If the two are different, it prompts the admin a yesno to change it
'** It is recomended that this script is ran from COMMAND PROMPT. It generally takes about 20 Seconds to read a folders permissions, 
'** so be patient. RUN ON LOCAL SERVER CONSOL, NOT THROUGH THE NETWORK.
'** Feel free to change as needed
'**
'**	TACTICAL TECH Administrative
'** Joshua R Heinreich, TacticalTechAdm@gmail.com, (706)-577-4660
'**********************************************************************************************************************************

'Script user variables
sourceFolder = "C:\temp"	'change to directory you want to scan (example:"C\test")
arrayAdmins = Array("Users", "Power Users", "Administrators", "SYSTEM", "CREATOR OWNER", "joshuar") 'add admin names and builtins
					

'Script Engine*********************************************************************************************************************


Set FSO = CreateObject("Scripting.FileSystemObject")
ShowSubfolders FSO.GetFolder(sourceFolder)	

Sub ShowSubFolders(Folder)
	For Each subFolder in folder.SubFolders
		wscript.echo subFolder				' remove me for ease of use	when running it outside of CMD Prompt
		isChanged = false
		Set objWMIService = GetObject("winmgmts:")
		Set objFolderSecuritySettings = objWMIService.Get("Win32_LogicalFileSecuritySetting='" & subFolder & "'")
			 
		subFolderName = replace(subFolder, folder&"\", "")
			 
		If objFolderSecuritySettings.GetSecurityDescriptor(objSD) = 0 Then
			For Each objAce in objSD.DACL
				isStandard = false
				for each objAdmin in arrayAdmins
					if objAdmin = objAce.Trustee.Name then 						isStandard = true
				next
				
				if isStandard = false and isChanged = false and objAce.Trustee.Name <> subFolderName then
					responce = MsgBox("Want to rename Folder "& subFolderName & " to " &  objAce.Trustee.Name &"?", vbYesNo, "Descrepency found")
					if responce = vbYes then
						folderSqlPath = replace(subFolder, "\", "\\")
						FSO.MoveFolder subFolder, folder & "\" & objAce.Trustee.Name
						subFolderName = objAce.Trustee.Name 
						wscript.echo "Changed"
						isChanged = true
					end if
						
				end if
			Next
		else
			wscript.echo "Unable to connect to folder permissions"
		End If
	next
	wscript.echo "Reached end of directory"
	msgbox( "Reached the end of the directory")
end sub
