'**************************************************************************************************
'**************************************************************************************************
'**This script determines is used to update the home directory for each user of an OU, determines
'**if it is a specific old server, and if it is, it changes the home directory to a new server   
'**address.	This script does NOT copy the files over to the new server or create a new folder for
'**the user, nor does it overwrite any files.													 
'**	Modify as needed.																			 
'**Joshua Heinreich  joshua.r.heinreich@us.army.mil, (706)-577-4660								
'**************************************************************************************************
'**************************************************************************************************


'Set the variables
ldapPath = "ou=Users,dc=Domain,dc=net"
newServerFQDN="HomeServ.domain.net"

'all these variables must be in lowercase
oldServer="oldhomeserv"
oldServerDomain ="domain.net"
oldServerIP = "192.168.2.3"



'****************Main Engine (Don't touch unless you know what you are doing)**********************


'set neccesary stuff for active directory manipulation
Const ADS_SCOPE_SUBTREE = 2

Set objConnection = CreateObject("ADODB.Connection")
Set objCommand = CreateObject("ADODB.Command")
objConnection.Provider = "ADsDSOObject"
objConnection.Open "Active Directory Provider"
Set objCommand.ActiveConnection = objConnection

'set properties of the command 
objCommand.Properties("Page Size") = 1000
objCommand.Properties("Searchscope") = ADS_SCOPE_SUBTREE

'set the SQL command
objCommand.CommandText = "SELECT AdsPath FROM 'LDAP://"&ldapPath&"' WHERE objectCategory = 'user'"
Set objRecordSet = objCommand.Execute

'sets the FQDN of the old server so the scripter doesn't have to
oldServerFQDN = oldServer &"."& oldServerDomain

'begin navigation of compiled list of users in the OU

objRecordSet.MoveFirst
Do Until objRecordSet.EOF 	'goes into a loop till end of file message is reached
	Set objUser = GetObject(objRecordSet.Fields("AdsPath").Value)
	dim strHomeDir
	dim chopHomeDir
	strHomeDir = objUser.homeDirectory 			' gets current homeDirectory setting
	if not IsEmpty(strHomeDir) then		' determines if it is a null setting or not. Will ignore the rest of this code if it is null
		
		'String Chop block to get the server being used. Server will be in segment 2, folder path in segment 3
		chopHomeDir = Split(strHomeDir,"\",4)
		packHomeDir = lcase(chopHomeDir(2))			'packages the choped up string into a nice lowercase package
		
		'decision point and write point
		on error resume next
		if packHomeDir  = oldServer or packHomeDir  = oldServerFQDN or packHomeDir = oldServerIP then		' determines if that package is the specified old server
			
			objUser.homeDirectory = "\\"&newServerFQDN&"\"&chopHomeDir(3)		' sets new homeDirectory path on new server, adds on the old file extension
			objUser.SetInfo						'saves the info to ADUC
			'wscript.echo objUser.homeDirectory					'used to help troubleshoot
		else
			'Space reserved for an error log writter: mainly to pick out the ones that have Varying CaSes in the server name
		end if
	End if
	
	objRecordSet.MoveNext		' moves on to the next record of the recordset
Loop
wscript.echo "done"
	